Subject: Re: [bitcoin-dev] Generalized covenants with taproot enable riskless or risky lending, prevent credit inflation through fractional reserve

From: ZmnSCPxj <[email-masked]>
Date: Fri, 05 Jul 2019 23:16:17 +0000

Good morning Eric,

Sent with ProtonMail Secure Email.

‐‐‐‐‐‐‐ Original Message ‐‐‐‐‐‐‐
On Saturday, July 6, 2019 3:27 AM, Eric Voskuil <[email-masked]> wrote:

> > On Jul 4, 2019, at 21:05, ZmnSCPxj [email-masked] wrote:
> > Good morning Eric,
> >
> > > As with Bitcoin mining, it is the consumed cost that matters in this scenario, (i.e., not the hash rate, or in this case the encumbered coin face value). Why would the advertiser not simply be required to burn .1 coin for the same privilege, just as miners burn energy? Why would it not make more sense to spend that coin in support of the secondary network (e.g. paying for confirmation security), just as with the burning of energy in Bitcoin mining?
>
> Good morning ZmnSCPxj,
>
> > Using the unspentness-time of a UTXO allows for someone advertising a service or producer to "close up shop" by simply spending the advertising UTXO.
> > For instance, if the advertisement is for sale of a limited stock of goods, once the stock has been sold, the merchant (assuming the merchant used own funds) can simply recover the locked funds, with the potential to reinvest them elsewhere.
> > This allows some time-based hedging for the merchant (they may be willing to wait indefinitely for the stock to be sold, but once the stock is sold, they can immediately reap the rewards of not having their funds locked anymore).
>
> This is a materially different concept than proposed by Tamas.
>
> “...he gives up his control of the coins until maturity, he can not use them elsewhere until then.”

Possibly.
In a way, this is giving up control of the coin, until he no longer needs the advertisement, i.e. dynamically select the maturity age needed.

> > Similarly, an entity renting out a UTXO for an advertisement might allow for early reclamation of the UTXO in exchange for partial refund of fee; as the value in the UTXO is now freed to be spent elsewhere, the lessor can lease it to another advertiser.
>
> You appear to be proposing a design whereby either the owner or the renter (not entirely clear to me which) can spend the “locked up” coin at any time (no maturity constraint), by dropping the covenant.
>
> If the renter can do this he can simply steal the coin from the owner.
>
> If the owner can do this there is no value to the renter (or as a proof of cost), as the owner retains full control of the coin.
>

Obviously this will require a 2-of-2 multisig, with an timelocked transaction that lets the owner recover at a futuredate, so that it is the agreement of *both* that is needed to perform any actions before the timelock.
I already described this in the link I provided.

> If you mean that the age of the encumbrance is the proof of cost, this requires no covenant. I don’t believe this is what you intended, just covering all bases.

Not age of encumbrance, quite.
Instead, it is the simple fact that the UTXO is a UTXO (and not yet spent), that validates the advertisement.

No, it does not *require* a covenant.
However, covenants do make it easier to use, in the sense that the renter can repurpose the UTXO (e.g. change details of advertisement) without having to contact the owner.

>
> > Burnt funds cannot be "un-burnt" to easily signal the end of a term for an advertisement.
>
> And as I have shown above, nor can a “locked-up” coin be unlocked to do the same.

You have shown no such thing, merely shown that you have not understood the proposal.

Regards,
ZmnSCPxj